import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQVQPOOOkQPO'#CeOOQO'#Cj'#CjOOQO'#Cf'#CfQVQPOOOOQO,59P,59POrQPO,59POOQO-E6d-E6dOOQO1G.k1G.k",
  stateData: "|~O]OS~OQQORQOSQOTQOUQOWPO~OVTO~PVOVWO~PVOTQ~",
  goto: "v_PPPPPPPPP`fPPPpXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ NuFormula Operator Keyword String Number VariableName ) ( Application",
  maxTerm: 14,
  nodeProps: [
    ["openedBy", 7,"("],
    ["closedBy", 8,")"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "*d~RbXY!ZYZ!Z]^!Zpq!Zrs!`xy$xyz$}z{%S{|%X}!O%X!O!P%d!P!Q%S!Q![&d!^!_&u!_!`%S!`!a'Q!c!}'Y#o#p'b~!`O]~~!cWpq!`qr!`rs!{s#O!`#O#P#Q#P;'S!`;'S;=`$r<%lO!`~#QOS~~#TXrs!`!P!Q!`#O#P!`#U#V!`#Y#Z!`#b#c!`#f#g!`#h#i!`#i#j#p~#sR!Q![#|!c!i#|#T#Z#|~$PR!Q![$Y!c!i$Y#T#Z$Y~$]R!Q![$f!c!i$f#T#Z$f~$iR!Q![!`!c!i!`#T#Z!`~$uP;=`<%l!`~$}OW~~%SOV~~%XOQ~~%^QQ~!O!P%d!Q![&d~%gP!Q![%j~%oRT~!Q![%j!g!h%x#X#Y%x~%{R{|&U}!O&U!Q![&[~&XP!Q![&[~&aPT~!Q![&[~&iST~!O!P%j!Q![&d!g!h%x#X#Y%x~&zQQ~!_!`%S!`!a%S~'VPQ~!_!`%S~'_PR~!c!}'Y~'eR!Q!['n!c!i'n#T#Z'n~'qS}!O'}!Q!['n!c!i'n#T#Z'n~(QR!Q![(Z!c!i(Z#T#Z(Z~(^S}!O(j!Q![(Z!c!i(Z#T#Z(Z~(mR!Q![(v!c!i(v#T#Z(v~(yS}!O)V!Q![(v!c!i(v#T#Z(v~)YR!Q![)c!c!i)c#T#Z)c~)fS}!O)r!Q![)c!c!i)c#T#Z)c~)uR!Q![*O!c!i*O#T#Z*O~*RS!Q![*O!c!i*O#T#Z*O#q#r*_~*dOU~",
  tokenizers: [0],
  topRules: {"NuFormula":[0,1]},
  tokenPrec: 41
});

const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Keyword: tags.keyword,
                String: tags.string,
                Number: tags.number,
                Operator: tags.operator,
                VariableName: tags.variableName,
                "( )": tags.paren,
                ",": tags.separator
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula };
